Index: gcc/fortran/match.c
===================================================================
*** gcc/fortran/match.c	(revision 126318)
--- gcc/fortran/match.c	(working copy)
*************** gfc_match_do (void)
*** 1500,1505 ****
--- 1500,1506 ----
    if (m == MATCH_ERROR)
      goto cleanup;
  
+   iter.var->symtree->n.sym->attr.implied_index = 0;
    gfc_check_do_variable (iter.var->symtree);
  
    if (gfc_match_eos () != MATCH_YES)
Index: gcc/testsuite/gfortran.dg/do_iterator_2.f90
===================================================================
*** gcc/testsuite/gfortran.dg/do_iterator_2.f90	(revision 0)
--- gcc/testsuite/gfortran.dg/do_iterator_2.f90	(revision 0)
***************
*** 0 ****
--- 1,32 ----
+ ! { dg-do run }
+ ! Tests the fix for pr32613 - see:
+ ! http://groups.google.com/group/comp.lang.fortran/browse_thread/thread/495c154ee188d7f1/ea292134fe68b1d0#ea292134fe68b1d0
+ !
+ ! Contributed by Al Greynolds <awgreynolds@earthlink.net>
+ !
+ program main
+   call something
+ end
+ 
+ subroutine something
+ !  integer i !correct results from gfortran depend on this statement (before fix)
+   integer :: m = 0
+   character lit*1, line*100
+   lit(i) = line(i:i)
+   i = 1
+   n = 5
+   line = 'PZ0R1'
+   if (internal (0)) call abort ()
+   if (m .ne. 5) call abort ()
+ contains
+   logical function internal (j)
+     intent(in) j
+     do i = j, n
+       k = index ('RE', lit (i))
+       m = m + 1
+       if (k == 0) cycle
+       if (i+1 == n) exit
+     enddo
+     internal = (k == 0)
+   end function
+ end
